var base64EncodeChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

function base64encode(str) {
    var out, i, len;
    var c1, c2, c3;

    len = str.length;
    i = 0;
    out = "";
    while(i < len) {
    c1 = str.charCodeAt(i++) & 0xff;
    if(i == len)
    {
        out += base64EncodeChars.charAt(c1 >> 2);
        out += base64EncodeChars.charAt((c1 & 0x3) << 4);
        out += "==";
        break;
    }
    c2 = str.charCodeAt(i++);
    if(i == len)
    {
        out += base64EncodeChars.charAt(c1 >> 2);
        out += base64EncodeChars.charAt(((c1 & 0x3)<< 4) | ((c2 & 0xF0) >> 4));
        out += base64EncodeChars.charAt((c2 & 0xF) << 2);
        out += "=";
        break;
    }
    c3 = str.charCodeAt(i++);
    out += base64EncodeChars.charAt(c1 >> 2);
    out += base64EncodeChars.charAt(((c1 & 0x3)<< 4) | ((c2 & 0xF0) >> 4));
    out += base64EncodeChars.charAt(((c2 & 0xF) << 2) | ((c3 & 0xC0) >>6));
    out += base64EncodeChars.charAt(c3 & 0x3F);
    }
    return out;
}

var base64DecodeChars = new Array(
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1, -1, 63,
    52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1, -1, -1, -1, -1, -1,
    -1,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14,
    15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, -1, -1, -1, -1, -1,
    -1, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
    41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, -1, -1, -1, -1, -1);

function base64decode(str) {
    var c1, c2, c3, c4;
    var i, len, out;

    len = str.length;
    i = 0;
    out = "";
    while(i < len) {
    /* c1 */
    do {
        c1 = base64DecodeChars[str.charCodeAt(i++) & 0xff];
    } while(i < len && c1 == -1);
    if(c1 == -1)
        break;

    /* c2 */
    do {
        c2 = base64DecodeChars[str.charCodeAt(i++) & 0xff];
    } while(i < len && c2 == -1);
    if(c2 == -1)
        break;

    out += String.fromCharCode((c1 << 2) | ((c2 & 0x30) >> 4));

    /* c3 */
    do {
        c3 = str.charCodeAt(i++) & 0xff;
        if(c3 == 61)
        return out;
        c3 = base64DecodeChars[c3];
    } while(i < len && c3 == -1);
    if(c3 == -1)
        break;

    out += String.fromCharCode(((c2 & 0XF) << 4) | ((c3 & 0x3C) >> 2));

    /* c4 */
    do {
        c4 = str.charCodeAt(i++) & 0xff;
        if(c4 == 61)
        return out;
        c4 = base64DecodeChars[c4];
    } while(i < len && c4 == -1);
    if(c4 == -1)
        break;
    out += String.fromCharCode(((c3 & 0x03) << 6) | c4);
    }
    return out;
}
    

function Wideo() {
    self = this;
    if (typeof console != "undefined") {
        self.log = console.log
    } else {
        if (typeof log != "undefined") {
            self.log = log
        }
    }
    self.sniffers = {
        //"youtube.com": self.sniffYouTube,
        //"xvideos.com": self.sniffXVideos,
        //"vimeo.com": self.sniffVimeo,
        //"mtv.com": self.sniffMTV,
        "cntv.cn": self.sniffCNTV,
        //"m1905.com": self.sniffM1905,
        "youku.com": self.sniffYouku,
        "qq.com": self.sniffQQ,
        //"letv.com": self.sniffLetv,
        "qiyi.com": self.sniffQiyi,
        "sohu.com": self.sniffSohu,
        "tudou.com": self.sniffTudou,
        "sina.com": self.sniffSina,
        "ku6.com": self.sniffKu6,
        "56.com": self.sniff56,
        "pptv.com": self.sniffPPTV,
        "163.com": self.sniff163,
        "yinyuetai.com": self.sniffYinyueTai,
        //"ted.com": self.sniffTed,
        "ifeng.com": self.sniffIfeng,
        "funshion.com": self.sniffFunshion,
        "pps.tv": self.sniffPPS,
        "wasu.cn": self.sniffWasu,
        "baomihua.com": self.sniffBaomihua,
        "pinshan.com": self.sniffPinshan,
        "v1.cn" : self.sniffV1,
        "1905.com" : self.sniff1905,
        "tangdou.com" : self.sniffTangdou,
        //"dailymotion.com": self.sniffDailymotion
    }
}
Wideo.prototype = {
    sniff: function (url,isDownload) {
        self.isDownload = isDownload;
        var c = {
            uri: null,
            title: null,
            video_uri: null,
            video_uri_sd: null,
            video_uri_ed: null,
            video_uri_hd720: null,
            video_uri_hd1080: null,
            header: null
        };
        var j = false;
        for (var b in self.sniffers) {
            if (new RegExp(b, "i").test(url)) {
                j = true
            }
        }
        if (!j) {
            log("can't find a sniffer");
            return c;
        }
        if (/youtube.com/i.test(url)) {
            url = url + "&nomobile=1"
        }
        if (/\/v.pps.tv/i.test(url)) {
            url = url.replace("v.pps.tv", "m.pps.tv")
        }
        for (var b in self.sniffers) {
            if (new RegExp(b, "i").test(url)) {
                log("found sniffer for " + b);
                //try {
                    var a = self.sniffers[b](url);
                    if (typeof a == "string") {
                        c.video_uri = a
                    } else {
                        if (a.video_uri_sd) c.video_uri_sd = a.video_uri_sd;
                        if (a.video_uri_ed) c.video_uri_ed = a.video_uri_ed;
                        if (a.video_uri_hd720) c.video_uri_hd720 = a.video_uri_hd720;
                        if (a.video_uri) c.video_uri = a.video_uri;
                        if(a.multiple){
                            c.multiple = a.multiple
                        }
                    }
                //} catch (err) {
                //    if (window.platform == "test") {
                //        throw err;
                //    }
                //}
                break
            }
        }
        if (platform == 'and')
            return JSON.stringify(c);
        else
            return c;
    },

    getHTML: function (url, headers) {
        if (!headers)
            headers = {
                "User-Agent" : "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_9_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.2062.20 Safari/537.36"
            };
        log("http get url: " + url);
        log("http get platform: " + platform);
        if (platform == "and")
            return getHtmlUrl(url, headers);
        if (platform == "ios") {
            return getHtmlUrl(url, headers);
        }
        if (platform == "test") {
//            importClass(com.waqu.videoscript.Functions);
            return Functions.httpget(url, headers);
        }
    },

    sniff163: function (url) {
        log("enter sniffer163");

        var b = self.getHTML(url);
        var a = null;
        try {
            a = /<source src="([^"]+.[m3u8|mp4])"/.exec(b)[1];
        } catch (d) {
            a = /appsrc : '([^"]+.[m3u8|mp4])',/.exec(b)[1];
        }
        if (self.isDownload) {
            return {}
        } else {
            return a;
        }
    },
    sniffCNTV: function (url) {
        log("enter snifferCNTV");
        var b = self.getHTML(url);
        var a = /"videoCenterId"\s*,\s*"([^"]*)"/.exec(b);
        if (!a) {
            a = /videoCenterId:\s*'([^']*)'/.exec(b);
        }
        a = a[1];
        if (self.isDownload) {
            return {};
        } else {
            return "http://asp.cntv.lxdns.com/hls/" + a + "/main.m3u8";
        }
    },

    sniffYouku: function (f) {
        log("enter sniffYouku");

        var a = null;
        try {
            a = /id_(.+)(_.*)(_.*)\.html/.exec(f)[1]
        } catch (h) {
            a = /id_(.+)\.html/.exec(f)[1]
        }
        
        
        function E(a, c) {
            for (var b = [], f = 0, i, d = "", h = 0; 256 > h; h++) b[h] = h;
            for (h = 0; 256 > h; h++) f = (f + b[h] + a.charCodeAt(h % a.length)) % 256, i = b[h], b[h] = b[f], b[f] = i;
            for (var q = f = h = 0; q < c.length; q++) {
                h = (h + 1) % 256, f = (f + b[h]) % 256, i = b[h], b[h] = b[f], b[f] = i, d += String.fromCharCode(c.charCodeAt(q) ^ b[(b[h] + b[f]) % 256]);
            }
            return d;
        }
        function calc_ep(fileid, ep) {
            var f_code_1 = 'becaf9be';
            var f_code_2 = 'bf7e5f01';
            e_code = E(f_code_1, base64decode(ep));
            sid = e_code.split("_")[0];
            token = e_code.split("_")[1];
            new_ep = E(f_code_2, sid + '_' + fileid + '_' + token);
            return {sid: sid, token: token, ep: base64encode(new_ep)};
        }
        
        
        var data = self.getHTML("http://v.youku.com/player/getPlayList/VideoIDS/" + a + '/Pf/4/ctype/12/ev/1');
        var info = JSON.parse(data).data[0];
        if (info['error_code'])
            return {};
        var videoid = info['videoid'];
        
        var seed = info.seed;
        var _cgStr = '';
        for (var a = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ/\\:._-1234567890", c = a.length, b = 0; b < c; b++) {
            seed = (211 * seed + 30031) % 65536;
            var f = parseInt(seed * a.length / 65536);
            _cgStr += a.charAt(f);
            a = a.split(a.charAt(f)).join("")
        }
        
        var vfiles = {}
        for (var stream_type in info.segs) {
            if (stream_type == '3gp' || stream_type == '3gphd') continue
            var hd = {"flv": 0, "mp4": 1, "hd2": 2, "3gphd": 1, "3gp": 0}[stream_type];
            var ext = {"flv": "flv", "mp4": "mp4", "hd2": "flv", "3gphd": "mp4", "3gp": "flv"}[stream_type];
            var uri_type = {"flv": "video_uri_sd", "mp4": "video_uri_ed", "hd2": "video_uri_hd720"}[stream_type];                    
            var tmpId = '';
            var ids = info.streamfileids[stream_type];
            
            for (var a = ids.split("*"), b = 0; b < a.length - 1; b++) 
                tmpId += _cgStr.charAt(a[b]);
                
            if (self.isDownload) {
                var filelist = new Array();
                for (idx in info.segs[stream_type]) {
                    vseg = info.segs[stream_type][idx];
                    fileno = vseg.no.toString(16);
                    1 == fileno.length && (fileno = "0" + fileno);
                    fileno = fileno.toUpperCase();
                    fileid = tmpId.slice(0, 8) + fileno + tmpId.slice(10, tmpId.length);
                    ep = calc_ep(fileid, info.ep);
                    fileurl = "/player/getFlvPath/sid/" + ep.sid + "_" + fileno + "/st/" + ext + "/fileid/" + fileid + "?K=" + vseg.k + "&hd=" + hd + "&myp=0&ts=" + vseg.seconds + "&ypp=0";
                    encoded_ep = ep.ep.replace(/\//g, '%2F').replace(/\+/g, '%2B')
                    fileurl = fileurl + ("&ep=" + encoded_ep) + "&ctype=12&ev=1" + ("&token=" + ep.token);
                    fileurl += "&oip=" + info.ip;
                    filelist.push('http://k.youku.com' + fileurl);
                }
                vfiles[uri_type] = filelist;
            } else {
                ep = calc_ep(videoid, info.ep);
                fileurl = 'vid=' + videoid + '&ts=' + Date.now() + '&keframe=1&type=' + stream_type + '&sid=' + ep.sid
                encoded_ep = ep.ep.replace(/\//g, '%2F').replace(/\+/g, '%2B')
                fileurl += '&ep=' + encoded_ep + '&ctype=12&ev=1&token=' + ep.token + '&oip=' + info.ip
                vfiles[uri_type] = 'http://pl.youku.com/playlist/m3u8?' + fileurl
            }
        }

        vfiles['video_uri'] = vfiles['video_uri_sd'];
        if (self.isDownload) {
            vfiles['multiple'] = true;
        }
        return vfiles;
    },
    sniffQQ: function (uri) {
        log("enter sniffQQ");

        var vid = null;
        try {
            vid = /page\/(\w+)\.html/.exec(uri)[1];
            
        } catch (err) {
            vid = /\?vid=(.+)/.exec(uri)[1];
            //try {
            //    vid = /vid\s*:\s*"([^"]+?)"/.exec(html)[1].split("|")[0]
            //} catch (e) {
            //    uri = /url=(.+)"/.exec(html)[1];
            //    vid = /\?vid=(.+)/.exec(uri)[1]
            //}
        }

        var body = self.getHTML("http://vv.video.qq.com/geturl?otype=json&vid=" + vid);
        var a = {};
        eval('a.' + body);
        return a.QZOutputJson.vd.vi[0].url

    },
    sniffLetv: function (url) {
        log("enter sniffLetv");
        
        var vid = /ptv\/vplay\/(\d+)\.html/i.exec(url)[1];
        var info = self.getHTML('http://api.letv.com/time');
        var t = JSON.parse(info).stime;
        var e;
        for (var i = 0; i < 8; i++) {
            e = 1 & t;
            t = t >> 1;
            e = e << 31;
            t += e;
        }
        key =  t ^ 185025305;
        if (self.isDownload) {
            var info_str = self.getHTML("http://api.letv.com/mms/out/common/geturl?platid=3&splatid=301&playid=0&vtype=9,13,21,28&version=2.0&tss=no&vid=" + vid + "&domain=www.letv.com&tkey=" + key);
            var info = JSON.parse(info_str);
            var locationinfo = JSON.parse(self.getHTML(info.data[0].infos[0].mainUrl + "&ctv=pc&m3v=1&termid=1&format=1&hwtype=un&ostype=Linux&tag=letv&sign=letv&expect=3&tn=" + Math.random() + "&pay=0&iscpn=f9051&rateid=1300"));
            return locationinfo['location']
        } else {
            var info_str = self.getHTML("http://api.letv.com/mms/out/common/geturl?platid=3&splatid=301&playid=0&vtype=9,13,21,28&version=2.0&tss=ios&vid=" + vid + "&domain=www.letv.com&tkey=" + key);
            var info = JSON.parse(info_str);
            var locationinfo = JSON.parse(self.getHTML(info.data[0].infos[0].mainUrl + "&ctv=pc&m3v=1&termid=1&format=1&hwtype=un&ostype=Linux&tag=letv&sign=letv&expect=3&tn=" + Math.random() + "&pay=0&iscpn=f9051&rateid=1300"));
            return locationinfo['location']
        }
    },

    
    sniffQiyi: function (url) {
        log("enter sniffQiyi");
        
        function get_key(r) {
            var n = [];
            t(n, 44);
            t(n, 2 * 5);
            t(n, 0 - 2);
            t(n, -1 * 2);
            t(n, -25);
            t(n, 5 * -11);
            t(n, 40);
            t(n, -16);
            t(n, 51);
            t(n, -4);
            n.concat([44, -38, 43, -53, -8]);

            function t(r, n) {
                r.push(n)
            }
            var o = [];
            for (var e = 0; e < n.length; e++) {
                if (e % 2 == 0) {
                    o.push(i(n[e] + 65))
                } else {
                    o.push(i(n[e] + 97))
                }
            }
            function i(r) {
                return String.fromCharCode(r)
            }
            var a = (new Date).getTime();
            t(o, a);
            t(o, r);
            var f = function(r) {
                    var n = [],
                        t = 0;
                    for (; t < 64;) {
                        n[t] = 0 | Math.abs(Math.sin(++t)) * 4294967296
                    }
                    function o(r, n) {
                        return ((r >> 1) + (n >> 1) << 1) + (r & 1) + (n & 1)
                    }
                    var e = function(t) {
                            var e, i, a, f, c = [],
                                u = unescape(encodeURI(t)),
                                _ = u.length,
                                d = [e = 1732584193, i = -271733879, ~e, ~i],
                                v = 0;
                            for (; v <= _;) c[v >> 2] |= (u.charCodeAt(v) || 128) << 8 * (v++ % 4);
                            c[t = (_ + 8 >> 6) * r + 14] = _ * 8;
                            v = 0;
                            for (; v < t; v += r) {
                                _ = d, f = 0;
                                for (; f < 64;) {
                                    _ = [a = _[3], o(e = _[1], (a = o(o(_[0], [e & (i = _[2]) | ~e & a, a & e | ~a & i, e ^ i ^ a, i ^ (e | ~a)][_ = f >> 4]), o(n[f], c[[f, 5 * f + 1, 3 * f + 5, 7 * f][_] % r + v]))) << (_ = [7, 12, 17, 22, 5, 9, 14, 20, 4, 11, r, 23, 6, 10, 15, 21][4 * _ + f++ % 4]) | a >>> 32 - _), e, i]
                                }
                                for (f = 4; f;) d[--f] = o(d[f], _[f])
                            }
                            t = "";
                            for (; f < 32;) t += (d[f >> 3] >> (1 ^ f++ & 7) * 4 & 15).toString(r);
                            return t
                        };
                    return e;
                }(16);
            var c = f(o.join(""));
            return c;
        }
        
        var html = self.getHTML(url);
        var vid, tvId;
        try {
            vid = /"videoId":"([^"]+?)"/.exec(html)[1];
            tvId = /"tvId"?\s*:\s*"(\d+)"/.exec(html)[1];
        } catch (e) {
            vid = /data-player-videoid="([^"]+?)"/.exec(html)[1];
            tvId = /data-player-tvid="([^"]+)"/.exec(html)[1];
        }
        var headers = {
            "Referer" : url,
            "User-Agent" : "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_9_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.2062.20 Safari/537.36"
        };
        if (self.isDownload) {
            var body = self.getHTML("http://cache.m.iqiyi.com/jp/tmts/" + tvId + "/" + vid + "/?type=mp4&platform=h5&__cliT=pad&__sigC=" + get_key(tvId) + "&__ctmM=" + Date.now(), headers);
            body = body.replace('var tvInfoJs=', '');
            var b = eval('(' + body + ')');
            return b.data.m3u;
        } else {
            var body = self.getHTML("http://cache.m.iqiyi.com/jp/tmts/" + tvId + "/" + vid + "/?type=m3u8&platform=h5&__cliT=pad&__sigC=" + get_key(tvId) + "&__ctmM=" + Date.now(), headers);
            body = body.replace('var tvInfoJs=', '')
            var b = eval('(' + body + ')');
            return b.data.m3u;
        }
        
    },
    
    
    sniffSohu: function (url) {
        log("enter sniffSohu");
        
        function _shift_en(i, key) {
            var t = i.length, e = 0;
            return key.replace(/[0-9a-zA-Z]/g, function(s) {
                var a = s.charCodeAt(0),
                    n = 65,
                    o = 26;
                a >= 97 ? n = 97 : 65 > a && (n = 48, o = 10);
                var r = a - n;
                return String.fromCharCode((r + i[e++ % t]) % o + n)
            })
        }
        
        var site = 1;
        if (/\/tv.sohu.com/i.test(url)) {
            url = url.replace("tv.sohu.com", "m.tv.sohu.com");
            site = 1;
        }
        if (/\/my.tv.sohu.com/i.test(url)) {
            url = url.replace("my.tv.sohu.com", "m.tv.sohu.com");
            site = 2;
        }
        
        var html = self.getHTML(url);
        
        var vid = /vid\s*:\s*"(\d+)"/.exec(html)[1];
        
        var info_url = "http://api.tv.sohu.com/v4/video/info/" + vid + ".json?api_key=695fe827ffeb7d74260a813025970bd5&plat=17&sver=1.0&partner=1&site=" + site;
	var body = self.getHTML(info_url);
        var b = eval('(' + body + ')');
        if (self.isDownload) {
            return b.data.url_high_mp4 + '&prod=h5';
        } else {
            //return b.data.url_high;
	    //m3u8解析出错
	    return b.data.url_high_mp4 + '&prod=h5';
        }
        
    },
    sniffTudou: function (url) {
        log("enter sniffTudou");

        var d = self.getHTML(url);
        if (/ykimg.com/.exec(d)) {
            var vid = /vcode:\s*["']([^"']+)["']/.exec(d)[1];
            if (vid) {
                return self.sniffYouku("http://v.youku.com/v_show/id_" + vid + ".html")
            }
        } else {
            var iid = /iid:\s*(\d+)/.exec(d)[1];
            if (self.isDownload) {
                return 'http://vr.tudou.com/v2proxy/v2?it=' + iid + '&st=52&pw=';
            } else {
                return 'http://vr.tudou.com/v2proxy/v2.m3u8?debug=1&it=' + iid + '&st=2&pw=';
            }
        }
        
    },
    
    sniffSina: function (uri) {
        log("enter sniffSina");

        var b = self.getHTML(uri);
        var a;
        try {
            a = /vid\s*:\s*'(.*?)'/.exec(b)[1].split("|")[0]
        } catch (d) {
            try {
                a = /\("vid", (.*)\)/.exec(b)[1]
            } catch (f) {
                a = /([^"]#(.*))/.exec(c)[2]
            }
        }
        return 'http://v.iask.com/v_play_ipad.php?vid=' + a;
    },
    
    
    sniffKu6: function (url) {
        log("enter sniffKu6");
        
        var vid = /show(.*)\/(.+)\.html/.exec(url)[2];
        if (self.isDownload) {
            var body = self.getHTML("http://v.ku6.com/fetchVideo4Player/" + vid + ".html");
            var b = JSON.parse(body);
            return b.data.f;
        } else {
            return "http://v.ku6.com/fetchwebm/" + vid + ".m3u8";
        }
    },
    
    
    sniff56: function (url) {
        log("enter sniff56");

        var a;
        try {
            a = /\/u\d+\/v_(\w+).html/.exec(url)[1]
        } catch (d) {
            a = /vid-(\w+).html/.exec(url)[1]
        }
        
        var body = self.getHTML("http://vxml.56.com/h5json/" + a + "/?src=m&callback=jsonp_dfInfo");
        var b = eval(/jsonp_dfInfo(.+);/.exec(body)[1]);
        if (b.df.length > 1)
            return b.df[1].url;
        else
            return b.df[0].url;

    },
    
    sniffPPTV: function (url) {
        log("enter sniffPPTV");
        var html = self.getHTML(url);
        var a = html.match(/"vid":(\d+)/)[1];
        var c = self.getHTML("http://web-play.pptv.com/webplay3-0-" + a + ".xml?version=4&type=m3u8.web.pad").body;
        var f = c.match(/rid="(.+?)\.mp4".*?ft="(\d)"/)[1] + ".m3u8";
        var d = c.match(/<bh>(.*?)<\/bh>/)[1];
        var b = c.match(/<key expire="[^"]+">(.*?)<\/key>/)[1];
        if (self.isDownload) {
            return {};
        } else {
            return "http://" + d + "/" + f + "?type=m3u8.web.pad&k=" + b;
        }
    },

    sniffPPS: function (url) {
        log("enter sniffPPS");
        var d = self.getHTML(url);
        var c = /"?url_key"?\s*:\s*"(\w+)"/.exec(d)[1];
        var b = /"?video_id"?\s*:\s*"(\d+)"/.exec(d)[1];
        var a = "http://active.v.pps.tv/ugc/ajax/aj_html5_url.php?url_key=" + c + "&video_id=" + b;
        var data = self.getHTML(a);
        var f = /"path":"([^"]*?)"/.exec(data)[1];
        return f.replace(/\\/g, "");
    },
    
    sniffWasu: function (url) {
        log("enter sniffWasu");
        var a = self.getHTML(url);
        var vid = /\/Play\/show\/id\/(\d+)/.exec(url)[1];
        var vkey = /_playUrl = '([^"]*?)'/.exec(a)[1];
        var playKey = /_playKey = \'(\w+)\'/.exec(a)[1];
        var info_url = "http://www.wasu.cn/wap/Api/getVideoUrl/id/" + vid + "/url/" + vkey + "/key/" + playKey + "/type/txt";
        return self.getHTML(info_url).replace('\n', '').replace('vodpcjq-cnc','wapvod-cnc') + '?vid='+ vid +'&version=MIPlayer_V1.3.2';
    },
    
    sniffYinyueTai: function (c) {
        log("enter sniffYinyueTai");

        var vid = /\/video\/(\d+)/.exec(c)[1];
        var data = self.getHTML("http://www.yinyuetai.com/insite/get-video-info?flex=true&videoId=" + vid);
        try {
            return /http:\/\/\w+\.yinyuetai\.com\/uploads\/videos\/common\/\w+\.(?:flv|mp4)\?(?:sc=[a-f0-9]{16}|v=\d{12})/.exec(data)[0];
        } catch(e) {
            data = self.getHTML("http://www.yinyuetai.com/main/get-mv-info?flex=true&videoId=" + vid);
            return /http:\/\/\w+\.yinyuetai\.com\/uploads\/videos\/common\/\w+\.(?:flv|mp4)\?(?:sc=[a-f0-9]{16}|v=\d{12})/.exec(data)[0];
        }
    },

    sniffFunshion: function (url) {
        var a = /\/(\d+)\/([^"])/.exec(url)[0];
        var e = self.getHTML("http://api.funshion.com/ajax/get_webplayinfo" + a + "/mp4").body;
        var f = JSON.parse(e).playinfos[0].cid;
        var d = self.getHTML("http://jobsfe.funshion.com/query/v1/mp4/" + f + ".json").body;
        return JSON.parse(d).playlist[0].urls[0]
    },
    
    sniffIfeng: function (url) {
        log('enter ifeng');
        var c = /([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})/.exec(url)[1];
        var i = c.substring(34);
        var a = i.substring(0, 1);
        var d = "http://v.ifeng.com/video_info_new/" + a + "/" + i + "/" + c + ".xml";
        var g = self.getHTML(d);
        return /VideoPlayUrl="([^"]+.mp4)"/.exec(g)[1];
    },
    
    sniffPinshan: function(url) {
        log('enter pinshan');
        var html = self.getHTML(url);
        
        try {
        	var vid = /var\s*v_id=\'(\w+)\';/.exec(html)[1];
        } catch (err) {
        	vid = /p\.bokecc\.com\/player\?.*vid=(\w+)/.exec(html)[1];
    	}
        
        var info_url = "http://p.bokecc.com/servlet/playinfo?vid=" + vid + "&m=1&pp=false&d=www.pinshan.com&vc=null&version=20140214";
        var content = self.getHTML(info_url);
        var urls = /<quality value="0" desp="普通">(.+?)<\/quality>/.exec(content)[1];
        return /playurl="([^"]+)"/.exec(urls)[1].replace('&', '&');
    },
    
    sniffBaomihua: function(url) {
        var vid = /in\/(\d+)/.exec(url)[1];
        var info_url = 'http://play.baomihua.com/getvideourl.aspx?flvid=' + vid;
        
        var content = self.getHTML(info_url);
        var host = /host=(.+?)&/.exec(content)[1];
//        var stream_name = /stream_name=(.+)&/.exec(content)[1];
        var ext = /videofiletype=(.+?)&/.exec(content)[1];
//        return 'http://' + host + '/pomoho_video/' + stream_name + '.' + ext;
        return 'http://' + host + '/pomoho_video/' + vid + '.' + ext;
    },
    
    sniffYouTube: function (c) {
        var a = /watch\?v=([^&]+)/.exec(c)[1];
        var b = self.getHTML(c);
        var d = /url_encoded_fmt_stream_map": "([^"]*)"/.exec(b)[1];
        d = d.split(",");
        url = d[0].split("\\u0026url=")[1];
        url = url.replace(/\\u0026/g, "&");
        url = decodeURIComponent(url);
        return url.replace("sig", "signature");
    },
    
    sniffV1: function (url) {
        var html = self.getHTML(url);
        return /src=\\"([^"]+.mp4)\\"/.exec(html)[1];
    },
    
    sniff1905: function (url) {
        var vid = /video\/play\/(\d+)\.shtml/.exec(url)[1];
        var data = self.getHTML('http://www.1905.com/api/video/getmediainfo.php?id=' + vid + '&type=1&source_key=mcfile');
        return base64decode(/"iosurl":"([^"]+)"/.exec(data)[1])
    },

    sniffTangdou: function (url) {
        var html = self.getHTML(url);
        
        if (/http:\/\/player.56.com\/tangdou_(\d+).swf/.exec(html)) {
            var vid56 = /http:\/\/player.56.com\/tangdou_(\d+).swf/.exec(html)[1];
            var body = self.getHTML("http://vxml.56.com/h5json/" + vid56 + "/?src=m&callback=jsonp_dfInfo");
            var b = eval(/jsonp_dfInfo(.+);/.exec(body)[1]);
            if (b.df.length > 1)
                return b.df[1].url;
            else
                return b.df[0].url;
        } else {
            //var vid = /http:\/\/union.bokecc.com\/flash\/pocle\/player.swf\?siteid=\w+&vid=(\w+)/.exec(html)[1]
            var vid = /siteid=\w+&vid=(\w+)/.exec(html)[1];
            var info_url = "http://p.bokecc.com/servlet/playinfo?vid=" + vid + "&m=1&pp=false&d=www.tangdou.com&vc=null&version=20140214";
            var content = self.getHTML(info_url);
            var urls = /<quality value="1" desp="清晰">(.+?)<\/quality>/.exec(content)[1];
            return /playurl="([^"]+)"/.exec(urls)[1].replace('&', '&');
        }
        return {};

    }
};


platform = "and";


function download(url,plat){
    platform = plat;
    log("enter download, platform is " + platform);
    var f = new Wideo();
    return f.sniff(url,true);
}

function sniff(url, plat) {
    platform = plat;
    log("enter sniff, platform is " + platform);
    var f = new Wideo();
    return f.sniff(url, false);
}
